// Задача "Интернет-банкинг"
// XVI командный чемпионат школьников Санкт-Петербурга по программированию
// Автор задачи: Антон Феськов, feskov@rain.ifmo.ru
// Автор решения: Сергей Поромов, poromov@rain.ifmo.ru

import java.io.*;
import java.util.*;

public class bank_sp implements Runnable {

	public static void main(String[] args) {
		new Thread(new bank_sp()).run();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(FILENAME + ".in"));
			out = new PrintWriter(FILENAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	BufferedReader br;

	PrintWriter out;

	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	void myAssert(boolean e, String s) {
		if (!e) {
			throw new Error("Assertion failure " + s);
		}
	}

	private static final String FILENAME = "bank";

	public void solve() throws IOException {
		int n = nextInt();
		String[] s = new String[n];
		for (int i = 0; i < n; i++) {
			s[i] = nextToken();
		}
		String ss = nextToken();
		int m = ss.length();
		int[] where = new int[m];
		Arrays.fill(where, -1);
		int[] c = new int[n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (s[i].charAt(j) != ss.charAt(j)) {
					c[i]++;
				} else {
					where[j] = i;
				}
			}
		}
		for (int i = 0; i < m; i++) {
			if (where[i] == -1) {
				out.println(-1);
				return;
			}
		}
		int imin = 0;
		for (int i = 0; i < n; i++) {
			if (c[i] < c[imin]) {
				imin = i;
			}
		}
		out.println(c[imin]);
		for (int i = 0; i < m; i++) {
			if (s[imin].charAt(i) != ss.charAt(i)) {
				out.println((imin + 1) + " " + (where[i] + 1) + " " + (i + 1));
			}
		}
	}
}
